#include <PalmOS.h>

#define DESIRED_NUM_TRAPS			0x3D9		//up to OS 3.5 level + a few from 4.0

#define OWNER_ID_FTR_ALLOCATED_CHUNKS	3


void __Startup__(void)
{
	UInt32 ver;
	Int16 i;
	
	//chunks of owner 3 are only freed in PalmOS 3.0+
	if (errNone == FtrGet(sysFtrCreator, sysFtrNumROMVersion, &ver) && ver < sysMakeROMVersion(3, 0, 0, 0, 0)) {
		
		for (i = 0; i < (Int16)MemNumRAMHeaps(0); i++) {
			
			UInt16 heap = MemHeapID(0, i);
			if (!MemHeapDynamic(heap))
				MemHeapFreeByOwnerID(heap, OWNER_ID_FTR_ALLOCATED_CHUNKS);
		}
	}
	
	//recyclable databases and temp databases only deleted in PalmOS 4.0+
	if (errNone == FtrGet(sysFtrCreator, sysFtrNumROMVersion, &ver) && ver < sysMakeROMVersion(4, 0, 0, 0, 0)) {
		
		for (i = 0; i < (Int16)DmNumDatabases(0); i++) {
			
			LocalID LID = DmGetDatabase(0, i);
			UInt32 type;
			UInt16 attr;
			
			if (errNone != DmDatabaseInfo(0, LID, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &type, NULL))
				continue;
			
			if ((attr & dmHdrAttrRecyclable) || type == sysFileTTemp) {
				
				if (errNone == DmDeleteDatabase(0, LID))
					i = 0;	//list may be reordered
			}
		}
	}
}



