#include <PalmOS.h>


//PalmOS 1.0 version does not support a NULL "db" parameter
//no db? use whatever the last db the app opened was. why? only "Card number "from the DB is used

/*	//		asm code is this:

SysAppInfoPtr SysCurAppInfoPV20(void)	SYS_TRAP(sysTrapSysCurAppInfoPV20);

static MemHandle pDmNewHandle(void* nextRetAddr, DmOpenRef db, UInt32 size)
{
	if (!db)
		db = (DmOpenRef)(SysCurAppInfoPV20()->dmAccessP);

	return oldTrap(db, size);
}

*/

#ifdef __GNUC__

	#define STRINGIFY2(x)	#x
	#define STRINGIFY(x)	STRINGIFY2(x)

	static void pDmNewHandleWrapper(/* DmOpenRef db, UInt32 size */)
	{
		//with no "naked" attribute available, this is a bit fragile, but as long as you do not try to compile with -O0, it will be ok
		
		asm volatile (
			"	move.l #0xbbbbbbbb, -(%sp)						\n\t"		//oldTrap - we'll "return" here
			"	move.l 8(%sp), %d0								\n\t"		//check DB
			"	bne    have_db									\n\t"
			"													\n\t"
			"no_db:												\n\t"
			"	dc.w   0x4e4f									\n\t"
			"	dc.w   " STRINGIFY(sysTrapSysCurAppInfoPV20)"	\n\t"
			"	move.l 0x1e(%a0), 8(%sp)						\n\t"//db = (DmOpenRef)(SysCurAppInfoPV20()->dmAccessP)			//yes, right on caller's stack, so sue me!
			"													\n\t"
			"have_db:											\n\t"
		);
	}
	
#else
	asm static void pDmNewHandleWrapper(DmOpenRef db, UInt32 size)
	{
		move.l #0xbbbbbbbb, -(sp)	//oldTrap - we'll "return" here
		move.l 8(sp), d0			//check DB
		bne    have_db
	
	no_db:
		dc.w   0x4e4f
		dc.w   sysTrapSysCurAppInfoPV20
		move.l 0x1e(a0), 8(sp)			//db = (DmOpenRef)(SysCurAppInfoPV20()->dmAccessP)			//yes, right on caller's stack, so sue me!
		
	have_db:
		rts
	}
#endif

void __Startup__(void)
{
	UInt32 ver;
	
	if (FtrGet(sysFtrCreator, sysFtrNumROMVersion, &ver) == errNone && ver < sysMakeROMVersion(2, 0, 0, 0, 0)) {
		
		MemSemaphoreReserve(true);
		*(UInt32*)(((UInt16*)pDmNewHandleWrapper) + 1) = (UInt32)SysGetTrapAddress(sysTrapDmNewHandle);
		MemSemaphoreRelease(true);
		
		SysSetTrapAddress(sysTrapDmNewHandle, pDmNewHandleWrapper);
		
		MemHandleLock(DmGet1Resource('extn', 3));
	}
}
