#include <stdio.h>
#include "swap.h"
#include "slk.h"

#define SLK_MAGIC_0		0xbe
#define SLK_MAGIC_1		0xef
#define SLK_MAGIC_2		0xed



#ifdef STATIC_SEARCH_WINDOW
	static uint8_t mSearchWindow[sizeof(struct SlkHdr)];
#endif


#ifndef __GNUC__		//codewarrior for 68k

	asm static uint16_t slkPrvCrc(const void *dataP, uint16_t len, uint16_t crcIn)
	{
		movea.l 4(sp), a0
		move.w  10(sp), d0
		move.w  8(sp), d1
		subq    #1, d1
		bmi.s   out
		lea     tab, a1
		ror.w   #8, d0
	byteloop:
		moveq   #0, d2
		move.b  (a0)+, d2
		eor.b   d0, d2
		add.w   d2, d2
		move.w  (a1, d2.w), d2
		lsr.w   #8, d0
		eor.w   d2, d0
		
		dbf     d1, byteloop
		ror.w   #8, d0
	out:
		rts
	
	tab:
		 dc.w 0x0; dc.w 0x2110; dc.w 0x4220; dc.w 0x6330; dc.w 0x8440; dc.w 0xa550; dc.w 0xc660; dc.w 0xe770; dc.w 0x881; dc.w 0x2991; dc.w 0x4aa1; dc.w 0x6bb1; dc.w 0x8cc1; dc.w 0xadd1; dc.w 0xcee1; dc.w 0xeff1; dc.w 0x3112; dc.w 0x1002; dc.w 0x7332; dc.w 0x5222; dc.w 0xb552; dc.w 0x9442; dc.w 0xf772; dc.w 0xd662; dc.w 0x3993; dc.w 0x1883; dc.w 0x7bb3; dc.w 0x5aa3; dc.w 0xbdd3; dc.w 0x9cc3; dc.w 0xfff3; dc.w 0xdee3; dc.w 0x6224; dc.w 0x4334; dc.w 0x2004; dc.w 0x114; dc.w 0xe664; dc.w 0xc774; dc.w 0xa444; dc.w 0x8554; dc.w 0x6aa5; dc.w 0x4bb5; dc.w 0x2885; dc.w 0x995; dc.w 0xeee5; dc.w 0xcff5; dc.w 0xacc5; dc.w 0x8dd5; dc.w 0x5336; dc.w 0x7226; dc.w 0x1116; dc.w 0x3006; dc.w 0xd776; dc.w 0xf666; dc.w 0x9556; dc.w 0xb446; dc.w 0x5bb7; dc.w 0x7aa7; dc.w 0x1997; dc.w 0x3887; dc.w 0xdff7; dc.w 0xfee7; dc.w 0x9dd7; dc.w 0xbcc7; dc.w 0xc448; dc.w 0xe558; dc.w 0x8668; dc.w 0xa778; dc.w 0x4008; dc.w 0x6118; dc.w 0x228; dc.w 0x2338; dc.w 0xccc9; dc.w 0xedd9; dc.w 0x8ee9; dc.w 0xaff9; dc.w 0x4889; dc.w 0x6999; dc.w 0xaa9; dc.w 0x2bb9; dc.w 0xf55a; dc.w 0xd44a; dc.w 0xb77a; dc.w 0x966a; dc.w 0x711a; dc.w 0x500a; dc.w 0x333a; dc.w 0x122a; dc.w 0xfddb; dc.w 0xdccb; dc.w 0xbffb; dc.w 0x9eeb; dc.w 0x799b; dc.w 0x588b; dc.w 0x3bbb; dc.w 0x1aab; dc.w 0xa66c; dc.w 0x877c; dc.w 0xe44c; dc.w 0xc55c; dc.w 0x222c; dc.w 0x33c; dc.w 0x600c; dc.w 0x411c; dc.w 0xaeed; dc.w 0x8ffd; dc.w 0xeccd; dc.w 0xcddd; dc.w 0x2aad; dc.w 0xbbd; dc.w 0x688d; dc.w 0x499d; dc.w 0x977e; dc.w 0xb66e; dc.w 0xd55e; dc.w 0xf44e; dc.w 0x133e; dc.w 0x322e; dc.w 0x511e; dc.w 0x700e; dc.w 0x9fff; dc.w 0xbeef; dc.w 0xdddf; dc.w 0xfccf; dc.w 0x1bbf; dc.w 0x3aaf; dc.w 0x599f; dc.w 0x788f; dc.w 0x8891; dc.w 0xa981; dc.w 0xcab1; dc.w 0xeba1; dc.w 0xcd1; dc.w 0x2dc1; dc.w 0x4ef1; dc.w 0x6fe1; dc.w 0x8010; dc.w 0xa100; dc.w 0xc230; dc.w 0xe320; dc.w 0x450; dc.w 0x2540; dc.w 0x4670; dc.w 0x6760; dc.w 0xb983; dc.w 0x9893; dc.w 0xfba3; dc.w 0xdab3; dc.w 0x3dc3; dc.w 0x1cd3; dc.w 0x7fe3; dc.w 0x5ef3; dc.w 0xb102; dc.w 0x9012; dc.w 0xf322; dc.w 0xd232; dc.w 0x3542; dc.w 0x1452; dc.w 0x7762; dc.w 0x5672; dc.w 0xeab5; dc.w 0xcba5; dc.w 0xa895; dc.w 0x8985; dc.w 0x6ef5; dc.w 0x4fe5; dc.w 0x2cd5; dc.w 0xdc5; dc.w 0xe234; dc.w 0xc324; dc.w 0xa014; dc.w 0x8104; dc.w 0x6674; dc.w 0x4764; dc.w 0x2454; dc.w 0x544; dc.w 0xdba7; dc.w 0xfab7; dc.w 0x9987; dc.w 0xb897; dc.w 0x5fe7; dc.w 0x7ef7; dc.w 0x1dc7; dc.w 0x3cd7; dc.w 0xd326; dc.w 0xf236; dc.w 0x9106; dc.w 0xb016; dc.w 0x5766; dc.w 0x7676; dc.w 0x1546; dc.w 0x3456; dc.w 0x4cd9; dc.w 0x6dc9; dc.w 0xef9; dc.w 0x2fe9; dc.w 0xc899; dc.w 0xe989; dc.w 0x8ab9; dc.w 0xaba9; dc.w 0x4458; dc.w 0x6548; dc.w 0x678; dc.w 0x2768; dc.w 0xc018; dc.w 0xe108; dc.w 0x8238; dc.w 0xa328; dc.w 0x7dcb; dc.w 0x5cdb; dc.w 0x3feb; dc.w 0x1efb; dc.w 0xf98b; dc.w 0xd89b; dc.w 0xbbab; dc.w 0x9abb; dc.w 0x754a; dc.w 0x545a; dc.w 0x376a; dc.w 0x167a; dc.w 0xf10a; dc.w 0xd01a; dc.w 0xb32a; dc.w 0x923a; dc.w 0x2efd; dc.w 0xfed; dc.w 0x6cdd; dc.w 0x4dcd; dc.w 0xaabd; dc.w 0x8bad; dc.w 0xe89d; dc.w 0xc98d; dc.w 0x267c; dc.w 0x76c; dc.w 0x645c; dc.w 0x454c; dc.w 0xa23c; dc.w 0x832c; dc.w 0xe01c; dc.w 0xc10c; dc.w 0x1fef; dc.w 0x3eff; dc.w 0x5dcf; dc.w 0x7cdf; dc.w 0x9baf; dc.w 0xbabf; dc.w 0xd98f; dc.w 0xf89f; dc.w 0x176e; dc.w 0x367e; dc.w 0x554e; dc.w 0x745e; dc.w 0x932e; dc.w 0xb23e; dc.w 0xd10e; dc.w 0xf01e; 
	}

#elif defined(HAVE_HW_CRC)
	
	#include "lpc802.h"
	
	static uint16_t slkPrvCrc(const void *dataP, uint_fast16_t len, uint16_t crc)
	{
		const uint8_t *src = (const uint8_t*)dataP;
		
		CRC->SEED = crc;
		while (len--)
			*(volatile uint8_t*)&CRC->WR_DATA = *src++;
		
		return CRC->SUM;
	}
		
#elif defined(__arm__) || defined(__i386__) || defined(__x86_64__)		//arm or x86

	static uint16_t slkPrvCrc(const void *dataP, uint_fast16_t len, uint16_t crc)
	{
		static const uint16_t crctab[] = { 0x0, 0x1021, 0x2042, 0x3063, 0x4084, 0x50a5, 0x60c6, 0x70e7, 0x8108, 0x9129, 0xa14a, 0xb16b, 0xc18c, 0xd1ad, 0xe1ce, 0xf1ef, 0x1231, 0x210, 0x3273, 0x2252, 0x52b5, 0x4294, 0x72f7, 0x62d6, 0x9339, 0x8318, 0xb37b, 0xa35a, 0xd3bd, 0xc39c, 0xf3ff, 0xe3de, 0x2462, 0x3443, 0x420, 0x1401, 0x64e6, 0x74c7, 0x44a4, 0x5485, 0xa56a, 0xb54b, 0x8528, 0x9509, 0xe5ee, 0xf5cf, 0xc5ac, 0xd58d, 0x3653, 0x2672, 0x1611, 0x630, 0x76d7, 0x66f6, 0x5695, 0x46b4, 0xb75b, 0xa77a, 0x9719, 0x8738, 0xf7df, 0xe7fe, 0xd79d, 0xc7bc, 0x48c4, 0x58e5, 0x6886, 0x78a7, 0x840, 0x1861, 0x2802, 0x3823, 0xc9cc, 0xd9ed, 0xe98e, 0xf9af, 0x8948, 0x9969, 0xa90a, 0xb92b, 0x5af5, 0x4ad4, 0x7ab7, 0x6a96, 0x1a71, 0xa50, 0x3a33, 0x2a12, 0xdbfd, 0xcbdc, 0xfbbf, 0xeb9e, 0x9b79, 0x8b58, 0xbb3b, 0xab1a, 0x6ca6, 0x7c87, 0x4ce4, 0x5cc5, 0x2c22, 0x3c03, 0xc60, 0x1c41, 0xedae, 0xfd8f, 0xcdec, 0xddcd, 0xad2a, 0xbd0b, 0x8d68, 0x9d49, 0x7e97, 0x6eb6, 0x5ed5, 0x4ef4, 0x3e13, 0x2e32, 0x1e51, 0xe70, 0xff9f, 0xefbe, 0xdfdd, 0xcffc, 0xbf1b, 0xaf3a, 0x9f59, 0x8f78, 0x9188, 0x81a9, 0xb1ca, 0xa1eb, 0xd10c, 0xc12d, 0xf14e, 0xe16f, 0x1080, 0xa1, 0x30c2, 0x20e3, 0x5004, 0x4025, 0x7046, 0x6067, 0x83b9, 0x9398, 0xa3fb, 0xb3da, 0xc33d, 0xd31c, 0xe37f, 0xf35e, 0x2b1, 0x1290, 0x22f3, 0x32d2, 0x4235, 0x5214, 0x6277, 0x7256, 0xb5ea, 0xa5cb, 0x95a8, 0x8589, 0xf56e, 0xe54f, 0xd52c, 0xc50d, 0x34e2, 0x24c3, 0x14a0, 0x481, 0x7466, 0x6447, 0x5424, 0x4405, 0xa7db, 0xb7fa, 0x8799, 0x97b8, 0xe75f, 0xf77e, 0xc71d, 0xd73c, 0x26d3, 0x36f2, 0x691, 0x16b0, 0x6657, 0x7676, 0x4615, 0x5634, 0xd94c, 0xc96d, 0xf90e, 0xe92f, 0x99c8, 0x89e9, 0xb98a, 0xa9ab, 0x5844, 0x4865, 0x7806, 0x6827, 0x18c0, 0x8e1, 0x3882, 0x28a3, 0xcb7d, 0xdb5c, 0xeb3f, 0xfb1e, 0x8bf9, 0x9bd8, 0xabbb, 0xbb9a, 0x4a75, 0x5a54, 0x6a37, 0x7a16, 0xaf1, 0x1ad0, 0x2ab3, 0x3a92, 0xfd2e, 0xed0f, 0xdd6c, 0xcd4d, 0xbdaa, 0xad8b, 0x9de8, 0x8dc9, 0x7c26, 0x6c07, 0x5c64, 0x4c45, 0x3ca2, 0x2c83, 0x1ce0, 0xcc1, 0xef1f, 0xff3e, 0xcf5d, 0xdf7c, 0xaf9b, 0xbfba, 0x8fd9, 0x9ff8, 0x6e17, 0x7e36, 0x4e55, 0x5e74, 0x2e93, 0x3eb2, 0xed1, 0x1ef0, };
	
		const uint8_t *data = (const uint8_t*)dataP;
		uint_fast8_t i;
		
		while (len--)
			crc = (crc << 8) ^ crctab[(crc >> 8) ^ *data++];
		
		return crc;
	}

#else	//gcc for 68k, where every cycle counts...
	
	static uint16_t __attribute__((noinline)) slkPrvCrc(const void *dataP, uint16_t len, uint16_t crc)
	{
		static const uint16_t tab[256] = {0x0, 0x2110, 0x4220, 0x6330, 0x8440, 0xa550, 0xc660, 0xe770, 0x881, 0x2991, 0x4aa1, 0x6bb1, 0x8cc1, 0xadd1, 0xcee1, 0xeff1, 0x3112, 0x1002, 0x7332, 0x5222, 0xb552, 0x9442, 0xf772, 0xd662, 0x3993, 0x1883, 0x7bb3, 0x5aa3, 0xbdd3, 0x9cc3, 0xfff3, 0xdee3, 0x6224, 0x4334, 0x2004, 0x114, 0xe664, 0xc774, 0xa444, 0x8554, 0x6aa5, 0x4bb5, 0x2885, 0x995, 0xeee5, 0xcff5, 0xacc5, 0x8dd5, 0x5336, 0x7226, 0x1116, 0x3006, 0xd776, 0xf666, 0x9556, 0xb446, 0x5bb7, 0x7aa7, 0x1997, 0x3887, 0xdff7, 0xfee7, 0x9dd7, 0xbcc7, 0xc448, 0xe558, 0x8668, 0xa778, 0x4008, 0x6118, 0x228, 0x2338, 0xccc9, 0xedd9, 0x8ee9, 0xaff9, 0x4889, 0x6999, 0xaa9, 0x2bb9, 0xf55a, 0xd44a, 0xb77a, 0x966a, 0x711a, 0x500a, 0x333a, 0x122a, 0xfddb, 0xdccb, 0xbffb, 0x9eeb, 0x799b, 0x588b, 0x3bbb, 0x1aab, 0xa66c, 0x877c, 0xe44c, 0xc55c, 0x222c, 0x33c, 0x600c, 0x411c, 0xaeed, 0x8ffd, 0xeccd, 0xcddd, 0x2aad, 0xbbd, 0x688d, 0x499d, 0x977e, 0xb66e, 0xd55e, 0xf44e, 0x133e, 0x322e, 0x511e, 0x700e, 0x9fff, 0xbeef, 0xdddf, 0xfccf, 0x1bbf, 0x3aaf, 0x599f, 0x788f, 0x8891, 0xa981, 0xcab1, 0xeba1, 0xcd1, 0x2dc1, 0x4ef1, 0x6fe1, 0x8010, 0xa100, 0xc230, 0xe320, 0x450, 0x2540, 0x4670, 0x6760, 0xb983, 0x9893, 0xfba3, 0xdab3, 0x3dc3, 0x1cd3, 0x7fe3, 0x5ef3, 0xb102, 0x9012, 0xf322, 0xd232, 0x3542, 0x1452, 0x7762, 0x5672, 0xeab5, 0xcba5, 0xa895, 0x8985, 0x6ef5, 0x4fe5, 0x2cd5, 0xdc5, 0xe234, 0xc324, 0xa014, 0x8104, 0x6674, 0x4764, 0x2454, 0x544, 0xdba7, 0xfab7, 0x9987, 0xb897, 0x5fe7, 0x7ef7, 0x1dc7, 0x3cd7, 0xd326, 0xf236, 0x9106, 0xb016, 0x5766, 0x7676, 0x1546, 0x3456, 0x4cd9, 0x6dc9, 0xef9, 0x2fe9, 0xc899, 0xe989, 0x8ab9, 0xaba9, 0x4458, 0x6548, 0x678, 0x2768, 0xc018, 0xe108, 0x8238, 0xa328, 0x7dcb, 0x5cdb, 0x3feb, 0x1efb, 0xf98b, 0xd89b, 0xbbab, 0x9abb, 0x754a, 0x545a, 0x376a, 0x167a, 0xf10a, 0xd01a, 0xb32a, 0x923a, 0x2efd, 0xfed, 0x6cdd, 0x4dcd, 0xaabd, 0x8bad, 0xe89d, 0xc98d, 0x267c, 0x76c, 0x645c, 0x454c, 0xa23c, 0x832c, 0xe01c, 0xc10c, 0x1fef, 0x3eff, 0x5dcf, 0x7cdf, 0x9baf, 0xbabf, 0xd98f, 0xf89f, 0x176e, 0x367e, 0x554e, 0x745e, 0x932e, 0xb23e, 0xd10e, 0xf01e, };
		uint32_t dummy;

		asm volatile(
			"	subq    #1, %2			\n\t"
			"	bmi.s   9f				\n\t"
			"	ror.w   #8, %3			\n\t"
			"1:							\n\t"
			"	moveq   #0, %1			\n\t"
			"	move.b  (%0)+, %1		\n\t"
			"	eor.b   %3, %1			\n\t"
			"	add.w   %1, %1			\n\t"
			"	move.w  (%4, %1.w), %1	\n\t"
			"	lsr.w   #8, %3			\n\t"
			"	eor.w   %1, %3			\n\t"
			"	dbf     %2, 1b			\n\t"
			"	ror.w   #8, %3			\n\t"
			"9:							\n\t"
			:"+a"(dataP), "=&d"(dummy), "+d"(len), "+d"(crc)
			:"a"(tab)
		);
		
		return crc;
	}
	
#endif


#ifdef LOG
	static void slkPrvLogPkt(struct bv *buf, uint_fast16_t maxLen, uint_fast16_t maxLen2)
	{
		uint_fast16_t i, j;
		bv_iter tv;
		
		if (maxLen > maxLen2)
			maxLen = maxLen2;
		
		for (i = 0, j = 0, tv = BV_START(buf); i < maxLen && BV_HAVEMORE(tv);) {
			
			if (j == BV_ITER_LEN(tv)) {
				
				tv = BV_NEXT(tv);
				j = 0;
				continue;
			}
			
			fprintf(stderr, " %02x", ((uint8_t*)(BV_ITER_PTR(tv)))[j]);
			i++;
			j++;
		}
		fprintf(stderr, "\n");
	}
#endif

bool slkRx(void *slkState, struct SlkHdr *hdr, struct bv *buf, uint32_t endTime)
{
	#ifndef STATIC_SEARCH_WINDOW
		uint8_t mSearchWindow[sizeof(struct SlkHdr)] = {0, };
	#endif

	uint16_t rxLen, crcRxed, now, crcCalced;
	uint_fast8_t i;
	uint8_t sum;
	bv_iter tv;
	
	do {
	
		do {
			
			uint8_t byte;
		
			if (!slkExtRx(slkState, &byte, 1, endTime))
				return false;
			
			//shift and sum at once
			sum = 0;
			for (i = 0; i < sizeof(mSearchWindow) - 1; i++)
				sum += mSearchWindow[i] = mSearchWindow[i + 1];
			mSearchWindow[i] = byte;
			sum -= byte;
			
		} while (mSearchWindow[0] != SLK_MAGIC_0 || mSearchWindow[1] != SLK_MAGIC_1 || mSearchWindow[2] != SLK_MAGIC_2 || sum);
		
		
		*hdr = *(const struct SlkHdr*)mSearchWindow;
		hdr->dataLen = rxLen = TO_U16(hdr->dataLen);
		
		//fprintf(stderr, " locked on header (tid %02x) with %u bytes of data\n", hdr->tid, rxLen);
		
		crcCalced = slkPrvCrc(mSearchWindow, sizeof(struct SlkHdr), 0);
		
		for (tv = BV_START(buf); rxLen && BV_HAVEMORE(tv); tv = BV_NEXT(tv), rxLen -= now) {
			
			now = BV_ITER_LEN(tv);
			
			if (now > rxLen)
				now = rxLen;
			
			if (!slkExtRx(slkState, BV_ITER_PTR(tv), now, endTime))
				return false;
			
			crcCalced = slkPrvCrc(BV_ITER_PTR(tv), now, crcCalced);
		}
		
		//check if we have unreceived data
		while (rxLen--) {
			
			uint8_t val;
			
			if (!slkExtRx(slkState, &val, 1, endTime))
				return false;
			
			crcCalced = slkPrvCrc(&val, 1, crcCalced);
		}
		
		if (!slkExtRx(slkState, &crcRxed, 2, endTime))
			return false;
		
	} while (TO_U16(crcRxed) != crcCalced);
		
#ifdef STATIC_SEARCH_WINDOW
	for (i = 0; i < sizeof(mSearchWindow); i++)
		mSearchWindow[i] = 0;
#endif
		
#ifdef LOG	
	uint_fast8_t j;
	fprintf(stderr, " RX slk packet %u -> %u type %u len %u: ", hdr->srcSck, hdr->dstSlk, hdr->pktTyp, hdr->dataLen);
	slkPrvLogPkt(buf, 16, hdr->dataLen);
	fprintf(stderr, "\n");
#endif
	
	return true;
}

void slkTx(void *slkState, struct SlkHdr *hdr, struct bv *buf)
{
	uint16_t len = 0, crc;
	bv_iter tv;
	
	for (tv = BV_START(buf); BV_HAVEMORE(tv); tv = BV_NEXT(tv))
		len += BV_ITER_LEN(tv);
	
#ifdef LOG
	fprintf(stderr, "TX slk packet %u -> %u type %u len %u: ", hdr->srcSck, hdr->dstSlk, hdr->pktTyp, len);
	slkPrvLogPkt(buf, 16, len);
	fprintf(stderr, "\n");
#endif

	crc = slkTxStart(slkState, hdr, len);
	
	for (tv = BV_START(buf); BV_HAVEMORE(tv); tv = BV_NEXT(tv))
		crc = slkTxBytes(slkState, crc, BV_ITER_PTR(tv), BV_ITER_LEN(tv));
	
	slkTxFinish(slkState, crc);
}

uint16_t slkTxStart(void *slkState, struct SlkHdr *hdr, uint16_t dataLen)
{
	const uint8_t *pkt = (const uint8_t*)hdr;
	uint_fast8_t i, sum = 0;
	
	hdr->magic[0] = SLK_MAGIC_0;
	hdr->magic[1] = SLK_MAGIC_1;
	hdr->magic[2] = SLK_MAGIC_2;
	hdr->dataLen = TO_U16(dataLen);
	
	for (i = 0; i < sizeof(struct SlkHdr) - 1; i++)
		sum += pkt[i];
	
	hdr->csum = sum;
	
	slkExtTx(slkState, hdr, sizeof(struct SlkHdr));
	return slkPrvCrc(hdr, sizeof(struct SlkHdr), 0);
}

uint16_t slkTxBytes(void *slkState, uint16_t state, void *dataP, uint16_t num)
{
	slkExtTx(slkState, dataP, num);
	return slkPrvCrc(dataP, num, state);
}

void slkTxFinish(void *slkState, uint16_t state)
{
	state = TO_U16(state);
	slkExtTx(slkState, &state, 2);
}
